package PureMessage::Policy::Events;
use strict;
use base 'Exporter';
use Carp qw(croak);

our @EXPORT_OK = qw(event_list event_valid event_passed
                delivery_action_list delivery_action_valid);

my %events = (
    connect => 0,
    envelope => 1,
    eoh => 2,
    body => 3,
    eom => 4,
    disconnect => 5,
    abort => 6,
    );


sub event_list {
    return keys %events;
}

sub event_valid {
    my $event = shift;
    return exists $events{$event};
}

sub event_passed {
    my $event1 = shift;
    my $event2 = shift;
    croak "invalid event: $event1" unless exists $events{$event1};
    croak "invalid event: $event2" unless exists $events{$event2};
    return ($events{$event1} >= $events{$event2});
}

my %delivery_actions = (
    keep => 1,
    discard => 1,
    reject => 1,
    tempfail => 1,
    quarantine => 1,
    route => 1,
    );

sub delivery_action_list {
    return keys %delivery_actions;
}

sub delivery_action_valid {
    my $action = shift;
    return exists $delivery_actions{$action};
}

1;
